<?php
/**
* @version Geommunity geocoder.php
* @author Adrien ROUSSEL
* @package joomla! community builder
* @subpackage Geommunity Geocoder
* @license http://www.gnu.org/licenses/gpl-3.0.html GNU/GPL
*/
// ensure this file is being included by a parent file
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) {
	die( 'Direct Access to this location is not allowed.' );
}

// register geocoder function
$_PLUGINS->registerFunction('onBeforeNewUser', 'geocodeUser', 'geommunitygeocoder');
$_PLUGINS->registerFunction('onBeforeUserUpdate', 'geocodeUser', 'geommunitygeocoder');
$_PLUGINS->registerFunction('onAfterUserRegistration', 'geocodeUser', 'geommunitygeocoder');

class geommunitygeocoder extends cbTabHandler
{
	function geocodeUser($user,$cbUser)
	{
		$db 	= JFactory::getDbo();
		$params = $this->params;
		$mode 	= $params->get('mode',0);
		$place 	= $this->geocodeAddress($params , $cbUser);
		
		if ( ($mode==1 && ($cbUser->cb_geolat == '' || $cbUser->cb_geolng == ''))||$mode==0 )
		{ 
			$cbUser->cb_geolat = $place['latitude'] ? $place['latitude'] : $cbUser->cb_geolat;
			$cbUser->cb_geolng = $place['longitude'] ? $place['longitude'] : $cbUser->cb_geolng;			
			$q ="UPDATE #__comprofiler 
			SET cb_geolat='".$cbUser->cb_geolat."',cb_geolng='".$cbUser->cb_geolng."' 
			WHERE id='".$cbUser->user_id."'";
			$db->setQuery($q);
           	$db->execute();
		}
	}
	
	function geocodeAddress($params , $cbUser )
	{
		$geoAddress = $params->get('geoAddress','cb_address');
		$geoCity 	= $params->get('geoCity','cb_city'); 
		$geoState 	= $params->get('geoState','cb_state');
		$geoCountry = $params->get('geoCountry','cb_country'); 
		$geoZipcode = $params->get('geoZipcode','cb_zipcode'); 
		$lat='cb_geolat';
		$lng='cb_geolng';

		$query = trim($cbUser->$geoAddress).','.trim($cbUser->$geoCity).','.trim($cbUser->$geoState).','.trim($cbUser->$geoZipcode).','.trim($cbUser->$geoCountry);
		$query = preg_replace('/^,|,$/', '', preg_replace('/(,)*/', '$1', $query));

		$query = urlencode($query);
		$result = $this->googleGeocode($query,$params);
		$lat = $result['lat'];
		$lng = $result['lng'];
		if ($lat == false || $lng == false || $lat=="0" || $lng=="0")
		{
			$result = $this->yahooGeocode($query, $params);
			$lat = $result['lat'];
			$lng = $result['lng'];
		}
		$place = array();
		$place['latitude'] = $lat ;
		$place['longitude'] = $lng ;
		return $place;
	}
	
	function googleGeocode($query,$params)
	{
		$debug = $params->get('debug',0);
		$geocoder_key	= $params->get('geocoder_key');
		$qurl = 'https://maps.googleapis.com/maps/api/geocode/xml?address='. $query;
		if($geocoder_key)
			$key = '&key='.$geocoder_key;
		$c = curl_init();
		curl_setopt($c, CURLOPT_URL, $qurl.$key);
		curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
		$xmlContent = trim(curl_exec($c));
		curl_close($c);
		if($debug || strpos($xmlContent,'OVER_QUERY_LIMIT'))
		{
			$app = JFactory::getApplication();
			$app->enqueueMessage('Google: '.$xmlContent.': <a href="'.$qurl.'" target="_blank">Google URL</a>');			
		}
		$xmlObject = simplexml_load_string($xmlContent);
		$result['lat'] = (string) $xmlObject->result->geometry->location->lat;
		$result['lng'] = (string) $xmlObject->result->geometry->location->lng;
		return $result;
	}
	function yahooGeocode($query,$params)
	{
	
		$debug = $params->get('debug',0);
		$geourl  = "https://query.yahooapis.com/v1/public/yql?q=select%20*%20from%20geo.placefinder%20where%20text%20%3D%20%221%20".$query."%22&format=json&diagnostics=true";
		if($debug)
		{
			$app = JFactory::getApplication();
			$app->enqueueMessage('<a href="'.$geourl.'" target="_blank">Yahoo URL</a> ');
		}	
		$xmlContent = file_get_contents($geourl);
		$obj = json_decode($xmlContent);
		$result['lat'] = (string) $obj->query->results->Result->latitude;
		$result['lng'] = (string) $obj->query->results->Result->longitude;	
		return $result;
	}
	
	function getDisplayTab($tab,$user,$ui)
	{
		global $_CB_framework,$ueConfig;
		$doc			= JFactory::getDocument();
		$juri 			= $_CB_framework->getCfg( 'live_site' );
		$lang 			= $_CB_framework->getCfg( 'lang' );
		$absolute_path 	= $_CB_framework->getCfg( 'absolute_path' );
		$my_id 			= $_CB_framework->myId();
		$userid 		= $user->id;
		$html ='';

		$languagePath=$absolute_path.'/components/com_comprofiler/plugin/user/plug_geommunitygeocoder';
		if (file_exists($languagePath.'/lang/'.$lang.'.php'))
		  include_once($languagePath.'/lang/'.$lang.'.php');
		else include_once($languagePath.'/lang/english.php');
		
		include_once JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.foundation.php';
		if($ueConfig['name_format']=='1' || $ueConfig['name_format']=='2')
			$fnaming 	= 'name';
		else
			$fnaming 	= 'username';
	
	
		$params = $this->params;
		
		$mymarker = '';

		
		$type = $params->get('type','ROADMAP');
		$width = $params->get('width','100%');
		$height = $params->get('height','400px');
		$zoom = $params->get('zoom','5');
		$minzoom = $params->get('minzoom','1');
		$maxzoom = $params->get('maxzoom','20');
		$scrollwheel = $params->get('scrollwheel',1);
		$qrcode = $params->get('qrcode',1);
		if($scrollwheel) $scrollwheel='true';
		else $scrollwheel='false';
		$showfriends = $params->get('showfriends',1);
		$showstreetview = $params->get('showstreetview',1);

		$stylez = $params->get('stylez');
		$js_apikey  	= $params->get('js_apikey');
		$js_client   	= $params->get('js_client');
		$js_signature  	= $params->get('js_signature');
		
		$user_username = ucfirst($user->$fnaming);
		
	

    	if ( 	$user->cb_geolng!="" && $user->cb_geolat!=""  && is_numeric($user->cb_geolat)  && is_numeric($user->cb_geolng)
				
			)
		{
      		$lat = $user->cb_geolat;
			$lng = $user->cb_geolng;

			$mapscript ="function add_Event(obj_, evType_, fn_){ 
						if (obj_.addEventListener)
							obj_.addEventListener(evType_, fn_, false); 
						else
							obj_.attachEvent('on'+evType_, fn_);  
					}		
	
	  function initializemap(){
				directionsDisplay = new google.maps.DirectionsRenderer();
				var latlng = new google.maps.LatLng(".$lat.",".$lng.");
				var myOptions = {
					zoom: ".$zoom.",
					minZoom: ".$minzoom.",
					maxZoom: ".$maxzoom.",
					center: latlng,
					mapTypeId: google.maps.MapTypeId.".$type.",
					scrollwheel: ".$scrollwheel.",
					navigationControl: true,
					scaleControl: true,
					mapTypeControl: true,
					streetViewControl: ".$showstreetview."
				}
				var map = new google.maps.Map(document.getElementById('map'), myOptions);
				directionsDisplay.setMap(map);
				directionsDisplay.setPanel(document.getElementById(\"directionspanel\"));
				var me = new google.maps.LatLng($lat,$lng);
				var marker = new google.maps.Marker({						
					position: me,
					map: map,
					clickable: true,					
					title:'".$user_username."'
				});
				
			
				var infobulle = new google.maps.InfoWindow({
				content:'".$user_username." ";

			$client = new JApplicationWebClient();
			if($qrcode && !$client->mobile)
			{
				$mapscript .="<div style=\'text-align:center\' title=\'"._GL_QRTITLE."\' class=\'hasTooltip\'><img src=\'//chart.googleapis.com/chart?cht=qr&chs=100x100&chl=geo%3A".$lat."%2C".$lng."\' width=\'100\' height=\'100\' alt=\'Geo QRCode\'/></div>";
			}
		
			$mapscript .="'});
				google.maps.event.addListener(marker,'click',function(){
					infobulle.open(map, marker);
				});
				infobulle.open(map, marker);";
		

			if($stylez!='')
			{
				$mapscript .="var stylez = ".$stylez.";
				var styledMapOptions = {
					name: '1'
				}
				var GeommunityLocatorMapType = new google.maps.StyledMapType( stylez, styledMapOptions);
				map.mapTypes.set('1', GeommunityLocatorMapType);
				map.setMapTypeId('1');";	
			}
			$mapscript .= $mymarker;
			$mapscript .= "}
			function initgmap() {
				arguments.callee.done = true;
				initializemap();
			};
    		add_Event(window, 'load', initgmap);";
			
			if($lat !=0 && $lng!=0 && $lat!='' && $lng!='')
			{		
				$api_url= '//maps.googleapis.com/maps/api/js?key='.$js_apikey;	
				$doc->addScript( $api_url );
						
				$doc->addScriptDeclaration($mapscript);
				$html .= "<div id=\"map\" style=\"height:".$height.";width:".$width.";\">";
		
				$html .= "</div>";
				$html .= '<a class="btn btn-small" href="javascript:initgmap();"><span class="icon-loop"></span> '._GL_RESETMAP.'</a>';		
			}
		}

		
		return $html;
	}
}
?>